<template>
  <div class="form-upload">
    <input :id="'upflie' + id" type="file" @change="previewFile()" /><br />
    <img :src="imageUrl" height="200" alt="Image preview..." />
  </div>
</template>

<script>
export default {
  name: 'Formupload',
  props: {
    id: {
      type: Number,
      default: 0
    },
    baseImg: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      imageUrl: ''
    };
  },
  watch: {
    baseImg: {
      handler (str) {
        this.imageUrl = ''
        if (str) {
          this.imageUrl = str
        }
      },
      deep: true,
      immediate: true
    }
  },
  methods: {
    beforeAvatarUpload (file) {
      const isJPG = file.type === 'image/jpeg' || file.type === 'image/png';
      const isLt2M = file.size / 1024 / 1024 < 2;

      if (!isJPG) {
        this.$message.error('上传头像图片只能是 JPG或者PNG 格式!');
        return
      }
      if (!isLt2M) {
        this.$message.error('上传头像图片大小不能超过 2MB!');
        return
      }
      return isJPG && isLt2M;
    },
    previewFile () {
      const that = this
      that.$nextTick(() => {
        const fileId = document.getElementById('upflie' + that.id)
        const file = fileId?.files[0]
        const reader = new FileReader()
        if (file) {
          if (!this.beforeAvatarUpload(file)) return
          reader.readAsDataURL(file)
          reader.onload = function (e) {
            that.imageUrl = e.target.result
          }
        }
      })
    }
  }
}
</script>

<style>
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
}
</style>